

    File: source\asm\gss.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_GSS - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.1 Alpha -- Oct, 2003
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;       _pli_GSS:   Acquire temporary stack storage
       9       9  0 +                                         ;                   of variable length.
      10      10  0 +                                         ;
      11      11  0 +                                         ;       parameters:
      12      12  0 +                                         ;         EAX contains the length of storage required
      13      13  0 +                                         ;       returns:
      14      14  0 +                                         ;         Stack storage of size ( [EAX]+4 ) rounded up
      15      15  0 +                                         ;         is obtained.  [EAX]+4 is stored at area+0.
      16      16  0 +                                         ;         The address of the area is returned in EAX
      17      17  0 +                                         ;         EAX and EDI are destroyed by this procedure.
      18      18  0 +                                         ;
      19      19  0 +                                         ;       This is non-PL/I compatible entry and linkage.
      20      20  0 +                                         ;       This code uses only EAX and EDI, so the caller
      21      21  0 +                                         ;       saves no registers.
      22      22  0 +                                         ;
      23      23  0 +                                         ;       dependencies: none (Intel calling sequence)
      24      24  0 +                                         ;
      25      25  0 +                                         ;       modifications:
      26      26  0 +                                         ;         2004-11-04 cleaned up and tested
      27      27  0 +                                         ;
      28      28  0 +                                         ;-------------------------------------------------------
      29      29  0 +            @Cpu=00000D9F                            .486P
      30      30  0 +                                                     .model flat,syscall
      31      31  0 +                                                     public _pli_GSS
      32      32  0 +
      33      33  0 +                                                     .code
      34      34  0 +            =00000000                        _pli_code equ $
      35      35  0 +                                             ;
      36      36  0 +                                             ;-----------------------------------------------------
      37      37  0 +                                             ;       _pli_GSS:  Get stack storage
      38      38  0 +                                             ;-----------------------------------------------------
      39      39  0 +  00000000  5F 70 6C 69 5F 47 53                     db   '_pli_GSS' ; Entry point name
                                 53
      40      40  0 +  00000008  08                                       db   8          ; Length of name
      41      41  0 +  00000009                                   _pli_GSS:
      42      42  0 +  00000009  5F                                       pop  edi        ; Pop return address
      43      43  0 +  0000000A  83 F8 00                                 cmp  eax,0      ; Make sure length is positive
      44      44  0 +  0000000D  7D 06 90 90 90 90                        jnl  ispos      ; Okay
      45      45  0 +  00000013  2B C0                                    sub  eax,eax    ; Otherwise make it zero
      46      46  0 +  00000015                                   ispos:
      47      47  0 +  00000015  83 C0 07                                 add  eax,7      ; Round up to dword+4
      48      48  0 +  00000018  83 E0 FC                                 and  eax,0fffffffCh
      49      49  0 +  0000001B  2B E0                                    sub  esp,eax    ; Get stack
      50      50  0 +                                             ; NOTE: Now use the first few bytes to save registers and do stack probes
      51      51  0 +  0000001D  89 04/24                                 mov  0[esp],eax ; Save length
      52      52  0 +  00000020  8D 44/24 [04]                            lea  eax,4[esp] ; Point to new stack data
      53      53  0 +  00000024  57                                       push edi        ; Restore return address
      54      54  0 +  00000025  C3                                       ret             ; Exit


    File: source\asm\gss.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      55      55  0 +                                                     end
