

    File: source\asm\incr.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_INC - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.1 Alpha -- Sep, 2007
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;
       9       9  0 +                                         ;       This module increments a dword in storage atomically
      10      10  0 +                                         ;       using the x86 CMPXCHG instruction.
      11      11  0 +                                         ;
      12      12  0 +                                         ;       Requires a 486 processor or higher.
      13      13  0 +                                         ;
      14      14  0 +                                         ;       This procedure doesn't save any registers.
      15      15  0 +                                         ;       PL/I will save ECX and EDX if used.  The call
      16      16  0 +                                         ;       destroys ESI, EDI, and EAX.
      17      17  0 +                                         ;
      18      18  0 +                                         ; Calling Sequence:
      19      19  0 +                                         ;       DCL inc ENTRY(PTR) returns(PTR)
      20      20  0 +                                         ;               OPTIONS(ASM LINKAGE(SYSTEM))
      21      21  0 +                                         ;               EXT( '_pli_INC' );
      22      22  0 +                                         ;       DCL  dword   fixed bin(31) static;
      23      23  0 +                                         ;       DCL  new_val fixed bin(31);
      24      24  0 +                                         ;       new_val = inc( addr(dword) );
      25      25  0 +                                         ;
      26      26  0 +                                         ;       The dword 'dword' will be incremented by one
      27      27  0 +                                         ;       and the updated value returned.
      28      28  0 +                                         ;
      29      29  0 +                                         ; To Do:
      30      30  0 +                                         ;
      31      31  0 +                                         ; Arguments:
      32      32  0 +                                         ;         EBP+8   Address of dword to increment
      33      33  0 +                                         ;
      34      34  0 +                                         ; Modifications:
      35      35  0 +                                         ;
      36      36  0 +                                         ;-------------------------------------------------------
      37      37  0 +            @Cpu=00000D9F                            .486P
      38      38  0 +                                                     .model flat,syscall
      39      39  0 +                                                     public _pli_INC
      40      40  0 +
      41      41  0 +                                                     include framedef.inc
      42  1    1  0 +                                             ;
      43  1    2  0 +                                             ;----------------------------------------------------+
      44  1    3  0 +                                             ;       PL/I Stack Frame Definition                  |
      45  1    4  0 +                                             ;----------------------------------------------------+
      46  1    5  0 +            =00000000                        frm_ebp equ      0      ; Previous caller's EBP 20040802
      47  1    6  0 +            =FFFFFFFC                        frm_edi equ     -4      ; Caller's EDI
      48  1    7  0 +            =FFFFFFF8                        frm_esi equ     -8      ; Caller's ESI
      49  1    8  0 +            =FFFFFFF4                        frm_ebx equ     -12     ; Caller's EBX
      50  1    9  0 +            =FFFFFFF0                        frm_epa equ     -16     ; Called Entry point address
      51  1   10  0 +            =FFFFFFEC                        frm_stt equ     -20     ; A(Statement number table)
      52  1   11  0 +            =FFFFFFE8                        frm_chc equ     -24     ; ONCB chain
      53  1   12  0 +            =FFFFFFE6                        frm_msk equ     -26     ; Condition mask
      54  1   13  0 +            =FFFFFFE4                        frm_epi equ     -28     ; Entry point id
      55  1   14  0 +            =FFFFFFE0                        frm_bos equ     -32     ; Current permanent BOS


    File: source\asm\incr.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      56  1   15  0 +            =00000020                        frm_len equ      32     ; Size of frame
      57  1   16  0 +
      58      42  0 +                                             ;------------------------------------------------+
      59      43  0 +                                             ;  Unique Stack Data for _pli_INC                |
      60      44  0 +                                             ;------------------------------------------------+
      61      45  0 +            =FFFFFFE0                        frm_loc equ     frm_bos         ; Start of locals for _pli_INC
      62      46  0 +            =FFFFFFE0                        loc_end equ     frm_loc         ; End of locals
      63      47  0 +            =00000000                        loc_len equ     frm_loc-loc_end ;
      64      48  0 +            =00000020                        frm_siz equ     frm_len+loc_len ; Total stack frame length
      65      49  0 +
      66      50  0 +                                                     .data
      67      51  0 +            =00000000                        _pli_data equ $
      68      52  0 +
      69      53  0 +                                                     .code                   ; PL/I Compatible entry code
      70      54  0 +            =00000000                        _pli_code equ $
      71      55  0 +  00000000  20 07 09 21 12 00 00                     db 20h,07h,09h,21h,12h,00h,00h,00h
                                 00
      72      56  0 +  00000008  5F 70 6C 69 5F 49 4E                     db '_pli_INC'
                                 43
      73      57  0 +  00000010  08                                       db 8
      74      58  0 +  00000011                                   _pli_INC:
      75      59  0 +  00000011  FF 17                                    call dword ptr 0[edi]
      76      60  0 +  00000013  00000020                                 dd frm_siz                      ; DSA size          20031007
      77      61  0 +  00000017  66:C7 45 [E4] 81E1                       mov word ptr -28[ebp],81E1h     ; Condition prefix flags
      78      62  0 +
      79      63  0 +  0000001D  8B 4D [08]                               mov ecx,dword ptr 8[ebp]        ; Load address of 'dword'
      80      64  0 +  00000020  8B 01                                    mov eax,dword ptr 0[ecx]        ; Load current value of 'dword'
      81      65  0 +  00000022                                   do_cmpxchg:                             ; Loop until we're succesful
      82      66  0 +  00000022  8B D0                                    mov edx,eax                     ; Increment by one
      83      67  0 +  00000024  42                                       inc edx                         ;   "
      84      68  0 +  00000025  F0:0F B1 11                       lock cmpxchg dword ptr 0[ecx],edx      ; 'dword'<- updated value if successful
      85      69  0 +  00000029  74 F7                                    je  do_cmpxchg                  ; loop if unsuccessful
      86      70  0 +                                             ;       (Updated value in EAX)
      87      71  0 +
      88      72  0 +                                             ;----------------------------------
      89      73  0 +                                             ;       Return to caller
      90      74  0 +                                             ;----------------------------------
      91      75  0 +  0000002B                                   ret:
      92      76  0 +  0000002B  8B 5D [F4]                               mov ebx,dword ptr -12[ebp]
      93      77  0 +  0000002E  8B 75 [F8]                               mov esi,dword ptr -8[ebp]
      94      78  0 +  00000031  8B 7D [FC]                               mov edi,dword ptr -4[ebp]
      95      79  0 +  00000034  C9                                       leave
      96      80  0 +  00000035  C3                                       ret
      97      81  0 +
      98      82  0 +            =00000036                        _pli_endc equ $
      99      83  0 +                                                     .data
     100      84  0 +  00000000                                           org _pli_data+00h
     101      85  0 +            =00000000                        _pli_endd equ $
     102      86  0 +                                                     end
