

    File: source\asm\plistart.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_Start - PL/I runtime support routines
       6       6  0 +                                         ;       Version 0.1 Alpha -- Dec, 2003
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;
       9       9  0 +                                         ;       PLISTART is statically linked with the user's .EXE.
      10      10  0 +                                         ;       It's function is to pass the address of the Global
      11      11  0 +                                         ;       Data Structure to _pli_Init, which performs the
      12      12  0 +                                         ;       actual initialization.
      13      13  0 +                                         ;
      14      14  0 +                                         ;       To Do:
      15      15  0 +                                         ;         . Get thread local storage for addr(TDA).
      16      16  0 +                                         ;         . Add country info.
      17      17  0 +                                         ;
      18      18  0 +                                         ;       Modifications:
      19      19  0 +                                         ;         2004-06-09 - Add 'maj_task_TDA'
      20      20  0 +                                         ;
      21      21  0 +                                         ;-------------------------------------------------------
      22      22  0 +            @Cpu=00000D8F                            .386P
      23      23  0 +                                                     .model flat,syscall
      24      24  0 +                                                     public _pli_Start
      25      25  0 +
      26      26  0 +                                                     .code
      27      27  0 +            =00000000                        _pli_code equ $
      28      28  0 +                                                     extern _pli_Init:near
      29      29  0 +                                                     extern _pli_IIC:near
      30      30  0 +                                             ;       WXTERNs for GET and PUT routines
      31      31  0 +                                                     extern _pli_Get(_pli_IIC):near
      32      32  0 +                                                     extern _pli_Put(_pli_IIC):near
      33      33  0 +                                             ;
      34      34  0 +                                             ;-----------------------------------------------------
      35      35  0 +                                             ;       _pli_Start:  Initialize PL/I MAIN procedure
      36      36  0 +                                             ;-----------------------------------------------------
      37      37  0 +  00000000  5F 70 6C 69 5F 53 74                     byte   '_pli_Start'             ; Entry point name
                                 61 72 74
      38      38  0 +  0000000A  0A                                       byte   10                       ; Length of name
      39      39  0 +  0000000B                                   _pli_Start:
      40      40  0 +  0000000B  8D 05 00000060:R                         lea  eax,maj_task_TDA           ; Load initial TDA address 20040609
      41      41  0 +  00000011  A3 [00000030]:R                          mov  gbl_TDA_anchor,eax         ; Store into GBL           20040609
      42      42  0 +  00000016  8D 05 00000000:R                         lea  eax,_pli_global_data
      43      43  0 +  0000001C  E9 00000000:E                            jmp  _pli_Init
      44      44  0 +
      45      45  0 +                                                     .data
      46      46  0 +            =00000000                        _pli_data equ $
      47      47  0 +                                             ;
      48      48  0 +                                             ;------------------------------------------------+
      49      49  0 +                                             ;       Global Data Area                         |
      50      50  0 +                                             ;------------------------------------------------+
      51      51  0 +  00000000                                           align   4
      52      52  0 +  00000000                                   _pli_global_data:
      53      53  0 +  00000000  00000060                         gbl_data_size   dword   gbl_data_len            ; Length of global data
      54      54  0 +  00000004  00000000                         gbl_return_code dword   0                       ; Return Code


    File: source\asm\plistart.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      55      55  0 +  00000008  00000000:E                       gbl_get_ep      dword   _pli_Get                ; Address of GET routine
      56      56  0 +  0000000C  00000000                                         dword   0                       ; (second word of entry)
      57      57  0 +  00000010  00000000:E                       gbl_put_ep      dword   _pli_Put                ; Address of PUT routine
      58      58  0 +  00000014  00000000                                         dword   0                       ; (second word of entry)
      59      59  0 +  00000018  00000000                                         dword   0                       ; (reserved)
      60      60  0 +  0000001C  00000000                                         dword   0                       ; "
      61      61  0 +  00000020  00000000                                         dword   0                       ; "
      62      62  0 +  00000024  00000000                                         dword   0                       ; "
      63      63  0 +  00000028  00000000                         gbl_User1       dword   0                       ; User field 1
      64      64  0 +  0000002C  00000000                         gbl_User2       dword   0                       ; User Field 2
      65      65  0 +  00000030  00000000                         gbl_TDA_anchor  dword   0                       ; addr(major_task_TDA)
      66      66  0 +  00000034  00000000                         gbl_alloc_cnt   dword   0                       ; Allocation count
      67      67  0 +                                             ;               Add country info?
      68      68  0 +                                             ;               Add addr(TDA_address) [TDA_address is stored in
      69      69  0 +                                             ;                 thread local storage.
      70      70  0 +  00000038  000A * ( 00000000 )                              dword   10 DUP(0)               ; (reserved, for now)
      71      71  0 +            =00000060                        gbl_data_len    equ     $-_pli_global_data      ; Area length
      72      72  0 +                                             ;               Expansion for _pli_global_data goes here
      73      73  0 +                                             ;
      74      74  0 +  00000060  0018 * ( 00000000 )              maj_task_TDA    dword  24 DUP(0)                ; Major task TDA (96 bytes) 20040609
      75      75  0 +
      76      76  0 +                                                     .stack  16384                           ; Minimal stack size for startup
      77      77  0 +
      78      78  0 +                                                     end _pli_Start
