

    File: source\asm\trap.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    1

    xxxx-ii-yyyy-cc-f--oooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


       1       1  0 +  0000                                   ;-------------------------------------------------------
       2       2  0 +                                         ;       Iron Spring PL/I Runtime Library Version 0.5
       3       3  0 +                                         ;          Distributed under the Gnu LGPL License
       4       4  0 +                                         ;
       5       5  0 +                                         ;       _pli_Trap - PL/I runtime trap handler
       6       6  0 +                                         ;       Version 0.1 Alpha -- Apr, 2002
       7       7  0 +                                         ;       Copyright Peter Flass
       8       8  0 +                                         ;
       9       9  0 +                                         ;       This module is called as a result of an OS/2
      10      10  0 +                                         ;       system exception.  It is a standard trap handler.
      11      11  0 +                                         ;       It is passed four parameters:
      12      12  0 +                                         ;       1. Address of the Exception Report Record
      13      13  0 +                                         ;       2. Address of PL/I's Exception Registration Record
      14      14  0 +                                         ;          The dword following the standard Registration Record
      15      15  0 +                                         ;          will contain the address of the current ATTENTION ONCB
      16      16  0 +                                         ;          for use by XCPT_SIGNAL processing.
      17      17  0 +                                         ;       3. Address of the Context Record
      18      18  0 +                                         ;       4. Address of the Dispatcher Context
      19      19  0 +                                         ;
      20      20  0 +                                         ;       Some exceptions [e.g. stack faults] should be handled
      21      21  0 +                                         ;       by this module.  The remainder will be signaled as
      22      22  0 +                                         ;       PL/I ON-CONDITIONS.
      23      23  0 +                                         ;
      24      24  0 +                                         ;       Modifications:
      25      25  0 +                                         ;         2006-11-01 - Fixup EBP from context record to
      26      26  0 +                                         ;                       provide a link over exception handler.
      27      27  0 +                                         ;         2006-09-21 - Try to continue exceptions
      28      28  0 +                                         ;         2004-12-22 -
      29      29  0 +                                         ;         2004-12-16 - Add dummy entry point
      30      30  0 +                                         ;         2004-05-27 - Remove debugging code
      31      31  0 +                                         ;
      32      32  0 +                                         ;-------------------------------------------------------
      33      33  0 +            @Cpu=00000D8F                            .386P
      34      34  0 +                                                     .model flat,syscall
      35      35  0 +
      36      36  0 +            =00000010                        ic_sig  equ 16                          ; 'SIGNAL' function code
      37      37  0 +
      38      38  0 +                                                     .data
      39      39  0 +            =00000000                        _pli_data equ $
      40      40  0 +  00000000  20 0F                            FPUCW   db 20h,0Fh                      ; Default x87 ctl word  20070910
      41      41  0 +                                                     extern _pli_PGT:near            ; Program Global Table
      42      42  0 +                                                     extern _pli_def_cond:near       ; Default condition flags
      43      43  0 +
      44      44  0 +                                                     include xcpt.inc
      45  1    1  0 +                                             ;--------------------------------------
      46  1    2  0 +                                             ;   xcpt.inc -- Assembler Definitions
      47  1    3  0 +                                             ;    for OS/2 system exceptions
      48  1    4  0 +                                             ;--------------------------------------
      49  1    5  0 +
      50  1    6  0 +            =00000000                        XCPT_CONTINUE_SEARCH            equ 000000000h
      51  1    7  0 +            =FFFFFFFF                        XCPT_CONTINUE_EXECUTION         equ 0FFFFFFFFh
      52  1    8  0 +            =00716668                        XCPT_CONTINUE_STOP              equ 000716668h
      53  1    9  0 +
      54  1   10  0 +            =00000001                        EH_NONCONTINUABLE               equ 000000001h
      55  1   11  0 +            =00000010                        EH_UNWINDING                    equ 000000010h


    File: source\asm\trap.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    2

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


      56  1   12  0 +            =00000100                        EH_EXIT_UNWIND                  equ 000000100h
      57  1   13  0 +            =00001000                        EH_STACK_INVALID                equ 000001000h
      58  1   14  0 +            =00010000                        EH_NESTED_CALL                  equ 000010000h
      59  1   15  0 +
      60  1   16  0 +            =80000001                        XCPT_GUARD_PAGE_VIOLATION       equ 080000001h
      61  1   17  0 +            =80010001                        XCPT_UNABLE_TO_GROW_STACK       equ 080010001h
      62  1   18  0 +            =C000009E                        XCPT_DATATYPE_MISALIGNMENT      equ 0C000009Eh
      63  1   19  0 +            =C000009F                        XCPT_BREAKPOINT                 equ 0C000009Fh
      64  1   20  0 +            =C00000A0                        XCPT_SINGLE_STEP                equ 0C00000A0h
      65  1   21  0 +            =C0000005                        XCPT_ACCESS_VIOLATION           equ 0C0000005h
      66  1   22  0 +            =C000001C                        XCPT_ILLEGAL_INSTRUCTION        equ 0C000001Ch
      67  1   23  0 +            =C0000094                        XCPT_FLOAT_DENORMAL_OPERAND     equ 0C0000094h
      68  1   24  0 +            =C0000095                        XCPT_FLOAT_DIVIDE_BY_ZERO       equ 0C0000095h
      69  1   25  0 +            =C0000096                        XCPT_FLOAT_INEXACT_RESULT       equ 0C0000096h
      70  1   26  0 +            =C0000097                        XCPT_FLOAT_INVALID_OPERATION    equ 0C0000097h
      71  1   27  0 +            =C0000098                        XCPT_FLOAT_OVERFLOW             equ 0C0000098h
      72  1   28  0 +            =C0000099                        XCPT_FLOAT_STACK_CHECK          equ 0C0000099h
      73  1   29  0 +            =C000009A                        XCPT_FLOAT_UNDERFLOW            equ 0C000009Ah
      74  1   30  0 +            =C000009B                        XCPT_INTEGER_DIVIDE_BY_ZERO     equ 0C000009Bh
      75  1   31  0 +            =C000009C                        XCPT_INTEGER_OVERFLOW           equ 0C000009Ch
      76  1   32  0 +            =C000009D                        XCPT_PRIVILEGED_INSTRUCTION     equ 0C000009Dh
      77  1   33  0 +            =C0000006                        XCPT_IN_PAGE_ERROR              equ 0C0000006h
      78  1   34  0 +            =C0010001                        XCPT_PROCESS_TERMINATE          equ 0C0010001h
      79  1   35  0 +            =C0010002                        XCPT_ASYNC_PROCESS_TERMINATE    equ 0C0010002h
      80  1   36  0 +            =C0000024                        XCPT_NONCONTINUABLE_EXCEPTION   equ 0C0000024h
      81  1   37  0 +            =C0000025                        XCPT_INVALID_DISPOSITION        equ 0C0000025h
      82  1   38  0 +            =C000001D                        XCPT_INVALID_LOCK_SEQUENCE      equ 0C000001Dh
      83  1   39  0 +            =C0000093                        XCPT_ARRAY_BOUNDS_EXCEEDED      equ 0C0000093h
      84  1   40  0 +            =C0010004                        XCPT_B1NPX_ERRATA02             equ 0C0010004h
      85  1   41  0 +            =C0000026                        XCPT_UNWIND                     equ 0C0000026h
      86  1   42  0 +            =C0000027                        XCPT_BAD_STACK                  equ 0C0000027h
      87  1   43  0 +            =C0000028                        XCPT_INVALID_UNWIND_TARGET      equ 0C0000028h
      88  1   44  0 +            =C0010003                        XCPT_SIGNAL                     equ 0C0010003h
      89  1   45  0 +
      90      45  0 +                                                     include framedef.inc
      91  1    1  0 +                                             ;
      92  1    2  0 +                                             ;----------------------------------------------------+
      93  1    3  0 +                                             ;       PL/I Stack Frame Definition                  |
      94  1    4  0 +                                             ;----------------------------------------------------+
      95  1    5  0 +            =00000000                        frm_ebp equ      0      ; Previous caller's EBP 20040802
      96  1    6  0 +            =FFFFFFFC                        frm_edi equ     -4      ; Caller's EDI
      97  1    7  0 +            =FFFFFFF8                        frm_esi equ     -8      ; Caller's ESI
      98  1    8  0 +            =FFFFFFF4                        frm_ebx equ     -12     ; Caller's EBX
      99  1    9  0 +            =FFFFFFF0                        frm_epa equ     -16     ; Called Entry point address
     100  1   10  0 +            =FFFFFFEC                        frm_stt equ     -20     ; A(Statement number table)
     101  1   11  0 +            =FFFFFFE8                        frm_chc equ     -24     ; ONCB chain
     102  1   12  0 +            =FFFFFFE6                        frm_msk equ     -26     ; Condition mask
     103  1   13  0 +            =FFFFFFE4                        frm_epi equ     -28     ; Entry point id
     104  1   14  0 +            =FFFFFFE0                        frm_bos equ     -32     ; Current permanent BOS
     105  1   15  0 +            =00000020                        frm_len equ      32     ; Size of frame
     106  1   16  0 +
     107      46  0 +
     108      47  0 +                                             ;------------------------------------------------+
     109      48  0 +                                             ;  Local Stack Data for _pli_Trap                |
     110      49  0 +                                             ;------------------------------------------------+


    File: source\asm\trap.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    3

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     111      50  0 +            =FFFFFFE0                        frm_loc equ     frm_bos         ; Start of locals for _pli_start
     112      51  0 +            =FFFFFFDC                        loc_edi equ     frm_loc-4       ; Caller's EDI
     113      52  0 +            =FFFFFFD8                        loc_ebp equ     frm_loc-8       ; Caller's EBP                  20061101
     114      53  0 +            =FFFFFFD8                        loc_end equ     frm_loc-8       ; End of local stack
     115      54  0 +            =00000008                        loc_len equ     frm_loc-loc_end ; Length of local stack
     116      55  0 +                                             ;----------------------------------------------------------------
     117      56  0 +
     118      57  0 +                                             ;------------------------------------------------+
     119      58  0 +                                             ;  Address of PGT                                |
     120      59  0 +                                             ;------------------------------------------------+
     121      60  0 +  00000002  00000000:E                       aPGT    dd    _pli_PGT
     122      61  0 +
     123      62  0 +            =00000006                        _pli_endd equ $
     124      63  0 +
     125      64  0 +                                                     .code
     126      65  0 +            =00000000                        _pli_code equ $
     127      66  0 +                                                     public _pli_Trap
     128      67  0 +                                                     extern DosExit:near
     129      68  0 +                                                     extern DosWrite:near
     130      69  0 +                                             ;
     131      70  0 +                                             ;-----------------------------------------------------
     132      71  0 +                                             ;       _pli_Trap:  OS/2 System Trap Handler
     133      72  0 +                                             ;       [NOT Standard PL/I Linkage]
     134      73  0 +                                             ;-----------------------------------------------------
     135      74  0 +  00000000  5F 70 6C 69 5F 54 72                     db   '_pli_Trap'        ; Entry point name
                                 61 70
     136      75  0 +  00000009  09                                       db   9                  ; Length of name
     137      76  0 +  0000000A                                   Dummy_Entry:                    ;                               20041216
     138      77  0 +  0000000A  FF 17                                    call dword ptr 0[edi]   ; Dummy entry                   20041216
     139      78  0 +  0000000C  00000000                                 dd   0                  ; Dummy DSA size                20041216
     140      79  0 +  00000010                                   _pli_Trap:                      ; Real entry                    20041216
     141      80  0 +                                             ;-------------------------------------------------------------
     142      81  0 +                                             ;       Build a PL/I-compatible stack frame for error handler
     143      82  0 +                                             ;-------------------------------------------------------------
     144      83  0 +  00000010  55                                       push ebp                ; Save caller's EBP
     145      84  0 +  00000011  8B EC                                    mov  ebp,esp            ; Save registers
     146      85  0 +  00000013  83 EC 28                                 sub  esp,frm_len+loc_len; Reserve stack frame
     147      86  0 +  00000016  89 65 [E0]                               mov  frm_bos[ebp],esp   ; Save BOS address
     148      87  0 +  00000019  89 7D [DC]                               mov  loc_edi[ebp],edi   ; Save caller's registers
     149      88  0 +  0000001C  89 75 [F8]                               mov  frm_esi[ebp],esi   ;   (edi,esi,ebx)
     150      89  0 +  0000001F  89 5D [F4]                               mov  frm_ebx[ebp],ebx
     151      90  0 +  00000022  C7 45 [F0]                               mov  dword ptr frm_epa[ebp],offset Dummy_Entry ; Entry   20041216
                                 0000000A:R
     152      91  0 +  00000029  C7 45 [EC] 00000000                      mov  dword ptr frm_stt[ebp],0           ; Statement number table
     153      92  0 +  00000030  C7 45 [E8] 00000000                      mov  dword ptr frm_chc[ebp],0           ; Condition handler chain
     154      93  0 +  00000037  66:A1 [00000000]:E                       mov  ax,word ptr _pli_def_cond          ; Enabled conditions
     155      94  0 +  0000003D  66:0D 0001                               or   ax,01h                             ; +Library function
     156      95  0 +  00000041  66:89 45 [E6]                            mov  frm_msk[ebp],ax    ; Condition mask
     157      96  0 +  00000045  8B 3D [00000002]:R                       mov  edi,aPGT           ; Load PGT address
     158      97  0 +  0000004B  89 7D [FC]                               mov  frm_edi[ebp],edi   ; Look like PL/I DSA for trace
     159      98  0 +  0000004E  8B 45 [00]                               mov  eax,frm_ebp[ebp]   ; Load caller's EBP             20061101
     160      99  0 +  00000051  89 45 [D8]                               mov  loc_ebp[ebp],eax   ; stash for return              20061101
     161     100  0 +  00000054  FC                                       cld                     ; Clear direction flag
     162     101  0 +                                             ;
     163     102  0 +                                             ;-----------------------------------------------------


    File: source\asm\trap.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    4

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     164     103  0 +                                             ;       Check exception code -- we should handle
     165     104  0 +                                             ;       stack problems here, ignore some stuff
     166     105  0 +                                             ;       and pass the rest to a PL/I error handler
     167     106  0 +                                             ;       (could be done via table of errors)
     168     107  0 +                                             ;----------------------------------------------------
     169     108  0 +  00000055  8B 75 [10]                               mov esi,16[ebp]         ; +8 A(ContextRecord)           20061101
     170     109  0 +  00000058  8B BE [00000098]                         mov edi,98h[esi]        ; A(ctx_ebp)                    20061101
     171     110  0 +  0000005E  89 7D [00]                               mov frm_ebp[ebp],edi    ; Save for backchain            20061101
     172     111  0 +  00000061  8B 75 [08]                               mov esi,8[ebp]          ; A(ExceptionReportRecord)
     173     112  0 +  00000064  8B 1E                                    mov ebx,dword ptr 0[esi]; Exception Number
     174     113  0 +  00000066  81 FB C0000026                           cmp ebx,XCPT_UNWIND     ; Check for expections to be ignored
     175     114  0 +  0000006C  0F 84 00000118:R                         je  nocont              ; Not continuable
     176     115  0 +  00000072  81 FB C000009F                           cmp ebx,XCPT_BREAKPOINT
     177     116  0 +  00000078  0F 84 00000122:R                         je  cont                ; Continuable (ignored)
     178     117  0 +  0000007E  81 FB C00000A0                           cmp ebx,XCPT_SINGLE_STEP
     179     118  0 +  00000084  0F 84 00000122:R                         je  cont
     180     119  0 +  0000008A  81 FB 80000001                           cmp ebx,XCPT_GUARD_PAGE_VIOLATION
     181     120  0 +  00000090  0F 84 00000122:R                         je  cont
     182     121  0 +  00000096  81 FB C0000024                           cmp ebx,XCPT_NONCONTINUABLE_EXCEPTION
     183     122  0 +  0000009C  74 7A 90 90 90 90                        je  nocont
     184     123  0 +  000000A2  81 FB C0010001                           cmp ebx,XCPT_PROCESS_TERMINATE
     185     124  0 +  000000A8  74 6E 90 90 90 90                        je  nocont
     186     125  0 +                                             ;       The following may unfortunately occur at inopportune times
     187     126  0 +                                             ;       and is not really an eror.
     188     127  0 +                                             ;       This code clears the exception flags in the context ares.
     189     128  0 +  000000AE  81 FB C0000096                           cmp ebx,XCPT_FLOAT_INEXACT_RESULT       ;               20070814
     190     129  0 +  000000B4  75 1E 90 90 90 90                        jne other                               ;               20070814
     191     130  0 +  000000BA  8B 5D [10]                               mov ebx,16[ebp]         ; A(contextRecord)              20070814
     192     131  0 +  000000BD  80 63 [08] DF                            and byte ptr 8[ebx],0DFh  ; Clear error status          20070814
     193     132  0 +  000000C1  F6 43 [08] 7F                            test byte ptr 8[ebx],07Fh ; Any other errors?           20070814
     194     133  0 +  000000C5  75 5B 90 90 90 90                        jnz cont                  ; Yes, continue               20070814
     195     134  0 +  000000CB  C6 43 [08] 00                            mov byte ptr 8[ebx],00h   ; No, clear summary Status    20070814
     196     135  0 +  000000CF  EB 51 90 90 90                           jmp cont                ; Continue this exception       20070814
     197     136  0 +
     198     137  0 +                                             ;-----------------------------------------------------
     199     138  0 +                                             ;       Other exceptions -
     200     139  0 +                                             ;       Call the PL/I condition handler (_pli_Sig)
     201     140  0 +                                             ;-----------------------------------------------------
     202     141  0 +  000000D4                                   other:
     203     142  0 +                                                                             ;                                       20070814
     204     143  0 +  000000D4  D9 2D [00000000]:R                       fldcw FPUCW             ; Load default x87 ctl word             20070910
     205     144  0 +  000000DA  8B 75 [0C]                               mov  esi,12[ebp]        ; +12 A(ExceptionRegistrationRecord)    20041222
     206     145  0 +  000000DD  8B 76 [08]                               mov  esi,8[esi]         ; A(ATTENTION ONCB)                     20041222
     207     146  0 +  000000E0  56                                       push esi                ;                                       20041222
     208     147  0 +  000000E1  8B 75 [10]                               mov  esi,16[ebp]        ; +8 A(ContextRecord)
     209     148  0 +  000000E4  56                                       push esi                ;
     210     149  0 +  000000E5  8B 75 [08]                               mov  esi,8[ebp]         ; +4 A(ExceptionReportRecord)
     211     150  0 +  000000E8  56                                       push esi                ;
     212     151  0 +  000000E9  6A 00                                    push 0                  ; +0 Code for System Exception
     213     152  0 +  000000EB  8B 7D [FC]                               mov  edi,frm_edi[ebp]   ; Load A(PGT) for PL/I call
     214     153  0 +  000000EE  B0 03                                    mov  al,3               ; Number of args for kicks
     215     154  0 +  000000F0  FF 57 [40]                               call dword ptr ic_sig*4[edi]    ; Call _pli_Sig
     216     155  0 +  000000F3  83 C4 0C                                 add  esp,12             ; Pop arguments off stack
     217     156  0 +
     218     157  0 +  000000F6  8B 75 [08]                               mov  esi,8[ebp]         ; A(ExceptionReportRecord)


    File: source\asm\trap.asm  Pass: 2   ALP: Assembly Language Processor  Ver 4.00.003   Page:    5

    xxxx-ii-yyyy-cc-f--oooooooo--gggggggggggggggggggg-zzz-mm-ddd--ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss


     219     158  0 +  000000F9  8B 1E                                    mov  ebx,dword ptr 0[esi]; Exception Number
     220     159  0 +  000000FB  81 FB C0010003                           cmp  ebx,XCPT_SIGNAL    ; Signal exception?
     221     160  0 +                                             ;       jne  nocont             ; ***Not Continuable***                 20060921
     222     161  0 +  00000101  75 1F 90 90 90 90                        jne  cont               ; No, continuable                       20060921
     223     162  0 +  00000107  8B 5E [14]                               mov  ebx,dword ptr 20[esi] ; ExceptionInfo[0]
     224     163  0 +  0000010A  83 FB 03                                 cmp  ebx,3              ; XCPT_SIGNAL_KILLPROC
     225     164  0 +  0000010D  74 09 90 90 90 90                        je   nocont             ; not continuable
     226     165  0 +  00000113  EB 0D 90 90 90                           jmp  cont               ; Continue if handler returns here
     227     166  0 +                                             ;
     228     167  0 +                                             ;-----------------------------------------------------
     229     168  0 +                                             ;       Return to OS/2 with or without
     230     169  0 +                                             ;       attempting to continue
     231     170  0 +                                             ;-----------------------------------------------------
     232     171  0 +  00000118                                   nocont:                         ; Don't continue
     233     172  0 +  00000118  B8 00000000                              mov eax,XCPT_CONTINUE_SEARCH
     234     173  0 +  0000011D  EB 08 90 90 90                           jmp return
     235     174  0 +  00000122                                   cont:                           ; Attempt to continue
     236     175  0 +  00000122  B8 FFFFFFFF                              mov eax,XCPT_CONTINUE_EXECUTION
     237     176  0 +  00000127                                   return:
     238     177  0 +  00000127  8B 5D [D8]                               mov ebx,loc_ebp[ebp]    ; Restore caller's EBP                  20070814
     239     178  0 +  0000012A  89 5D [00]                               mov frm_ebp[ebp],ebx    ;                                       20070814
     240     179  0 +  0000012D  8B 5D [F4]                               mov ebx,dword ptr frm_ebx[ebp]
     241     180  0 +  00000130  8B 75 [F8]                               mov esi,dword ptr frm_esi[ebp]
     242     181  0 +  00000133  8B 7D [DC]                               mov edi,dword ptr loc_edi[ebp]
     243     182  0 +  00000136  C9                                       leave
     244     183  0 +  00000137  C3                                       ret
     245     184  0 +
     246     185  0 +            =00000138                        _pli_endc equ $
     247     186  0 +
     248     187  0 +                                                     end
